Name:		mosquitto
Version:	0.8.2
Release:	1%{?dist}
Summary:	An Open Source MQTT v3 Broker

Group:		Applications/System
License:	BSD
URL:		http://mosquitto.org
Source:		http://mosquitto.org/files/source/%{name}-%{version}.tar.gz
Patch0:		mosquitto-0.8.2-no-install-strip.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:	sqlite >= 3.6.14.1, tcp_wrappers
BuildRequires:	sqlite-devel, tcp_wrappers-devel, python-devel

%if "%_lib" == "lib64"
%define LIB_SUFFIX 64
%else
%define LIB_SUFFIX %nil
%endif

%description
Mosquitto is a message broker that implements the MQ Telemetry Transport 
protocol version 3. MQTT provides a lightweight method of carrying out 
messaging using a publish/subscribe model.

%package clients
Summary: Mosquitto command line pub/sub clients
Group: Applications/Communications

%description clients
This is two MQTT version 3 clients. The first can publish messages to a broker,
the second can subscribe to multiple topics on a broker.

%package libs
Summary: MQTT C client library
Group: Development/Libraries

%description libs
This is a library that provides a means of implementing MQTT version 3
clients. MQTT provides a lightweight method of carrying out messaging using a
publish/subscribe model.

%package devel
Summary: MQTT C and C++ client library development files
Group: Development/Libraries

%description devel
This is a library that provides a means of implementing MQTT version 3
clients. MQTT provides a lightweight method of carrying out messaging using a
publish/subscribe model.

%package -n python-mosquitto
Summary: MQTT Python client library
Group: Development/Libraries
Requires: python

%description -n python-mosquitto
This is a library that provides a means of implementing MQTT version 3
clients. MQTT provides a lightweight method of carrying out messaging using a
publish/subscribe model.

%prep
%setup -q
%patch0 -p1

%build
awk '$1~/^\#persistence$/{print "persistence 1";next}
	$1~/^\#persistence_location$/{print "persistence_location /var/lib/mosquitto/";;next}
	{print $0}' mosquitto.conf > mosquitto.conf.tmp
mv mosquitto.conf.tmp mosquitto.conf
# For now we turn off regexp as it requires a sqlite plugin we don't have yet
sed -e "s/^#define WITH_REGEX/\/\/#define WITH_REGEX/" config.h > config.h.tmp
mv config.h.tmp config.h
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install prefix=%{_prefix} LIB_SUFFIX=%{LIB_SUFFIX} DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/init
cp service/upstart/mosquitto.conf $RPM_BUILD_ROOT/etc/init
# tidy up installed files
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.so
chmod -x $RPM_BUILD_ROOT/%{_includedir}/*.h

%clean
rm -rf $RPM_BUILD_ROOT

%post
getent passwd mosquitto >/dev/null || useradd -k /dev/null -r -m -d /var/lib/mosquitto/ -s /sbin/nologin mosquitto

%post -n mosquitto-libs -p /sbin/ldconfig

%postun -n mosquitto-libs -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc ChangeLog.txt readme.txt
%config(noreplace) /etc/init/mosquitto.conf
/usr/sbin/mosquitto
%config(noreplace) /etc/mosquitto.conf
%doc /usr/share/man/man5/mosquitto.conf.5.gz
%doc /usr/share/man/man7/mqtt.7.gz
%doc /usr/share/man/man8/mosquitto.8.gz

%files clients
%defattr(-,root,root,-)
/usr/bin/mosquitto_pub
/usr/bin/mosquitto_sub
%doc /usr/share/man/man1/mosquitto_pub.1.gz
%doc /usr/share/man/man1/mosquitto_sub.1.gz

%files libs
%defattr(-,root,root,-)
%{_libdir}/libmosquitto.so*
%{_libdir}/libmosquittopp.so*
%doc /usr/share/man/man3/libmosquitto.3.gz

%files devel
%defattr(-,root,root,-)
%doc ChangeLog.txt readme.txt
/usr/include/mosquitto.h
/usr/include/mosquittopp.h

%files -n python-mosquitto
%defattr(-,root,root,-)
%doc ChangeLog.txt readme.txt
/usr/lib*/python*/site-packages/mosquitto-0.8*.egg-info
/usr/lib*/python*/site-packages/mosquitto.py*

%changelog
* Fri Sep 24 2010 Eric Sandeen <sandeen@redhat.com> 0.8.2-1
- Initial build
